setwd("Q:/SeventhPlan/RPM - Model/Technical Appendix/")

genesys <- read.fwf("Source Files/Hourly Output 80 Years.vbi", widths=c(4, 3, 3, 3, rep(8, 11)), skip=5)
names(genesys) <- c("FY", "Period", "Day", "Hour", "Load", "Curtailment", "Thermal", "Purchases", "Hydro", 
                    "Wind", "Transmission", "ReserveRqmt", "HydroReserve", "ThermalReserve", "ReserveViol")

PeriodToMo <- function(x){
  x[x == 8] <- 7.5
  x[x >= 9] <- x[x >= 9] - 1
  x[x == 12] <- 11.5
  x[x == 13] <- 12
  x <- (x + 9) %% 12
  x[x == 0] <- 12 
  x
}

genesys$Month <- PeriodToMo(genesys$Period)
genesys$Year <- genesys$FY
genesys$Year[genesys$Month >= 10] <- genesys$FY[genesys$Month >= 10] - 1
genesys$Date <- as.Date(sprintf("%04d-%02d-%02d", genesys$Year, genesys$Month, genesys$Day))
genesys$WY <- rep(1929:2008, each=8760)
genesys$HLH <- !(genesys$Hour < 7 | genesys$Hour > 22 | format(genesys$Date, "%a") == "Sun")
genesys$Quarter <- floor((genesys$Month-1)/3 + 1)
qhydro <- aggregate(Hydro ~ WY + Quarter + HLH, data=genesys, FUN=mean, na.rm=TRUE)
qhydro.wide <- reshape(qhydro, idvar=c("WY", "Quarter"), timevar="HLH", direction="wide")
qhydro.wide$CY <- qhydro.wide$WY
qhydro.wide$CY[qhydro.wide$Quarter == 4] <- qhydro.wide$WY[qhydro.wide$Quarter == 4] - 1
qhydro.wide[order(qhydro.wide$CY, qhydro.wide$Quarter),]


